common real s(30,30,30,5), a(5,5,30,30), b(5,5,30,30), c(5,5,30,30)

! 

! subroutine btrix_

formal integer js
formal integer je
formal integer ls
formal integer le
formal integer k

    integer j, l, m, n
    real c1, d1, d2, d3, d4, d5, c2, c3, c4, c5, l11(30), l21(30), l31(30), l41(30), u12(30), u13(30), u14(30), u15(30), u23(30), u24(30), u25(30), u34(30), u35(30), u45(30), l51(30), l22(30), l32(30), l42(30), l52(30), l33(30), l43(30), l53(30), l44(30), l54(30), l55(30)

! 
!     VECTORIZED BLOCK TRI-DIAGONAL SOLVER IN THE J DIRECTION
!          FOR K = CONSTANT PLANES
! 
!   11/15/84  D H BAILEY  MODIFIED FOR NAS KERNEL TEST
! 
! 
! 
! 
!     PART 1.  FORWARD BLOCK SWEEP
! 
! 
    do j = js, je {
! 
! **********   STEP 1.  CONSTRUCT L(I) IN B    **************************
! 
! was IF(J.NE.JS) then
	if (j > js) then
	    do m = 1, 5 {
		do n = 1, 5 {
		    do l = ls, le {
			b(m,n,j,l) = b(m,n,j,l) - a(m,1,j,l) * b(1,n,j - 1,l) - a(m,2,j,l) * b(2,n,j - 1,l) - a(m,3,j,l) * b(3,n,j - 1,l) - a(m,4,j,l) * b(4,n,j - 1,l) - a(m,5,j,l) * b(5,n,j - 1,l)
		    }
		}
	    }
	endif
! 
! **********    STEP 2.  CONPUTE L INVERSE    ***************************
! 
! 
!        A.  DECOMPOSE L(I) INTO L AND U
! 
	do l = ls, le {
	    l11(l) = 1. / b(1,1,j,l)
	    u12(l) = b(1,2,j,l) * l11(l)
	    u13(l) = b(1,3,j,l) * l11(l)
	    u14(l) = b(1,4,j,l) * l11(l)
	    u15(l) = b(1,5,j,l) * l11(l)
	    l21(l) = b(2,1,j,l)
	    l22(l) = 1. / (b(2,2,j,l) - l21(l) * u12(l))
	    u23(l) = (b(2,3,j,l) - l21(l) * u13(l)) * l22(l)
	    u24(l) = (b(2,4,j,l) - l21(l) * u14(l)) * l22(l)
	    u25(l) = (b(2,5,j,l) - l21(l) * u15(l)) * l22(l)
	    l31(l) = b(3,1,j,l)
	    l32(l) = b(3,2,j,l) - l31(l) * u12(l)
	    l33(l) = 1. / (b(3,3,j,l) - l31(l) * u13(l) - l32(l) * u23(l))
	    u34(l) = (b(3,4,j,l) - l31(l) * u14(l) - l32(l) * u24(l)) * l33(l)
	    u35(l) = (b(3,5,j,l) - l31(l) * u15(l) - l32(l) * u25(l)) * l33(l)
	}
! 
	do l = ls, le {
	    l41(l) = b(4,1,j,l)
	    l42(l) = b(4,2,j,l) - l41(l) * u12(l)
	    l43(l) = b(4,3,j,l) - l41(l) * u13(l) - l42(l) * u23(l)
	    l44(l) = 1. / (b(4,4,j,l) - l41(l) * u14(l) - l42(l) * u24(l) - l43(l) * u34(l))
	    u45(l) = (b(4,5,j,l) - l41(l) * u15(l) - l42(l) * u25(l) - l43(l) * u35(l)) * l44(l)
	    l51(l) = b(5,1,j,l)
	    l52(l) = b(5,2,j,l) - l51(l) * u12(l)
	    l53(l) = b(5,3,j,l) - l51(l) * u13(l) - l52(l) * u23(l)
	    l54(l) = b(5,4,j,l) - l51(l) * u14(l) - l52(l) * u24(l) - l53(l) * u34(l)
	    l55(l) = 1. / (b(5,5,j,l) - l51(l) * u15(l) - l52(l) * u25(l) - l53(l) * u35(l) - l54(l) * u45(l))
	}
! 
! **********    STEP 3.  SOLVE FOR INTERMEDIATE VECTOR    ***************
! 
!         A.  CONSTRUCT RHS
! 
! was IF(J.NE.JS) THEN
	if (j > js) then
	    do m = 1, 5 {
		do l = ls, le {
		    s(j,k,l,m) = s(j,k,l,m) - a(m,1,j,l) * s(j - 1,k,l,1) - a(m,2,j,l) * s(j - 1,k,l,2) - a(m,3,j,l) * s(j - 1,k,l,3) - a(m,4,j,l) * s(j - 1,k,l,4) - a(m,5,j,l) * s(j - 1,k,l,5)
		}
	    }
	endif
! 
!         B. INTERMEDIATE VECTOR
! 
! 
!         FWD SUBSTITUTION
! 
	do l = ls, le {
	    d1 = s(j,k,l,1) * l11(l)
	    d2 = (s(j,k,l,2) - l21(l) * d1) * l22(l)
	    d3 = (s(j,k,l,3) - l31(l) * d1 - l32(l) * d2) * l33(l)
	    d4 = (s(j,k,l,4) - l41(l) * d1 - l42(l) * d2 - l43(l) * d3) * l44(l)
	    d5 = (s(j,k,l,5) - l51(l) * d1 - l52(l) * d2 - l53(l) * d3 - l54(l) * d4) * l55(l)
! 
!         BWD SUBSTITUTION
! 
	    s(j,k,l,5) = d5
	    s(j,k,l,4) = d4 - u45(l) * d5
	    s(j,k,l,3) = d3 - u34(l) * s(j,k,l,4) - u35(l) * d5
	    s(j,k,l,2) = d2 - u23(l) * s(j,k,l,3) - u24(l) * s(j,k,l,4) - u25(l) * d5
	    s(j,k,l,1) = d1 - u12(l) * s(j,k,l,2) - u13(l) * s(j,k,l,3) - u14(l) * s(j,k,l,4) - u15(l) * d5
	}
! 
! **********    STEP 4.  CONSTRUCT U(I) = L(I)**(-1)*C(I+1)    **********
! **********             BY COLUMNS AND STORE IN B            **********
! 
! was IF(J.NE.JE) THEN
	if (j < je) then
	    do n = 1, 5 {
		do l = ls, le {
! 
!         FWD SUBSTITUTION
! 
		    c1 = c(1,n,j,l) * l11(l)
		    c2 = (c(2,n,j,l) - l21(l) * c1) * l22(l)
		    c3 = (c(3,n,j,l) - l31(l) * c1 - l32(l) * c2) * l33(l)
		    c4 = (c(4,n,j,l) - l41(l) * c1 - l42(l) * c2 - l43(l) * c3) * l44(l)
		    c5 = (c(5,n,j,l) - l51(l) * c1 - l52(l) * c2 - l53(l) * c3 - l54(l) * c4) * l55(l)
! 
!         BWD SUBSTITUTION
! 
		    b(5,n,j,l) = c5
		    b(4,n,j,l) = c4 - u45(l) * c5
		    b(3,n,j,l) = c3 - u34(l) * b(4,n,j,l) - u35(l) * c5
		    b(2,n,j,l) = c2 - u23(l) * b(3,n,j,l) - u24(l) * b(4,n,j,l) - u25(l) * c5
		    b(1,n,j,l) = c1 - u12(l) * b(2,n,j,l) - u13(l) * b(3,n,j,l) - u14(l) * b(4,n,j,l) - u15(l) * c5
		}
	    }
	endif
! 
! 
    }
! 
!     PART 2.  BACKWARD BLOCK SWEEP
! 
! was DO 200 J = JE-1,JS,-1
    do j = 1, je - js {
	do m = 1, 5 {
	    do l = ls, le {
		s(j,k,l,m) = s(j,k,l,m) - b(m,1,j,l) * s(j + 1,k,l,1) - b(m,2,j,l) * s(j + 1,k,l,2) - b(m,3,j,l) * s(j + 1,k,l,3) - b(m,4,j,l) * s(j + 1,k,l,4) - b(m,5,j,l) * s(j + 1,k,l,5)
	    }
	}
    }
! 

