! 

! subroutine cholsky_

formal integer ida
formal integer nmat
formal integer m
formal integer n
formal real a(0:ida,-m:0,0:n)
formal integer nrhs
formal integer idb
formal real b(0:nrhs,0:idb,0:n)

    static real eps = 1e-13

    ! Builtin functions
    builtin real r_abs(), r_sqrt()

    ! Local variables
    real epss(0:256)
    integer i, j, k, l, i0, jj, kk

! 
!   CHOLESKY DECOMPOSITION/SUBSTITUTION SUBROUTINE.
! 
!   11/28/84  D H BAILEY  MODIFIED FOR NAS KERNEL TEST
! 
! 
!  CHOLESKY DECOMPOSITION
! 
    do j = 0, n {
	i0 = max(-m,-j)
! 
!  OFF DIAGONAL ELEMENTS
! 
	do i = i0, -1 {
	    do jj = i0 - i, -1 {
		do l = 0, nmat {
		    a(l,i,j) = a(l,i,j) - a(l,jj,i + j) * a(l,i + jj,j)
		}
	    }
	    do l = 0, nmat {
		a(l,i,j) = a(l,i,j) * a(l,0,i + j)
	    }
	}
! 
!  STORE INVERSE OF DIAGONAL ELEMENTS
! 
	do l = 0, nmat {
	    epss(l) = eps * a(l,0,j)
	}
	do jj = i0, -1 {
	    do l = 0, nmat {
		a(l,0,j) = a(l,0,j) - a(l,jj,j) ** 2
	    }
	}
	do l = 0, nmat {
	    a(l,0,j) = 1. / r_sqrt(r_abs(epss(l) + a(l,0,j)))
	}
    }
! 
!  SOLUTION
! 
    do i = 0, nrhs {
	do k = 0, n {
	    do l = 0, nmat {
		b(i,l,k) = b(i,l,k) * a(l,0,k)
	    }
	    do jj = 1, min(m,n - k) {
		do l = 0, nmat {
		    b(i,l,k + jj) = b(i,l,k + jj) - a(l,-jj,k + jj) * b(i,l,k)
		}
	    }
	}
! 
! was   DO 6 K = N, 0, -1
	do kk = 0, n {
	    k = n - kk
	    do l = 0, nmat {
		b(i,l,k) = b(i,l,k) * a(l,0,k)
	    }
	    do jj = 1, min(m,k) {
		do l = 0, nmat {
		    b(i,l,k - jj) = b(i,l,k - jj) - a(l,-jj,k) * b(i,l,k)
		}
	    }
	}
    }
! 

