!
! subroutine emit
!
!  emit new vortices to satisfy boundary condition.
!  finish computing pressure, forces, etc.
!
!   11/28/84  d h bailey  modified for nas kernel test
!
const nw = 100
const nb = 5
const nvm = 1500
real expwkl,expmwk, dum3
! ,force,uupstr,dum3,expz,expmz,zz
real wall(nw,nb),rmatrx(nw*nb,nw*nb),zcr(nw,nb),z(nvm),gamma(nvm),refpt(nb),rhs(nw*nb),force(nb), rmom(nb),cp(nw,nb),dpds(nw,nb),expz(nvm),expmz(nvm),psi(nw),ps(nvm)
!
real period, sig2, u0, delta, chord, pi, uupstr, pidp, cupst, sps, cpm
integer matdim
integer nv,i0,nolld
integer nwall(nw)
!
!  store exp(z(i)) and exp(-z(i)) to reduce work in inner loop 4.
!
nv = 1000
pidp = pi/period
!
do i = 1,nv {
	expz(i) = z(i)*pidp
	expmz(i) = 1./expz(i)
	}
!
i0 = 0
cupst = uupstr*uupstr
!
do l = 1,nb {
	do k = 1,nwall(l) {
		expwkl = wall(k,l)*pidp
		expmwk = 1./expwkl
		sps = 0.
		do i = 1,nv {
			dum3 = expz(i)*expmwk-expwkl*expmz(i)
			ps(i) = gamma(i)*dum3**2+dum3**2+sig2
			sps = sps+ps(i)
			}
		psi(k) = wall(k,l)*uupstr+u0-sps*0.25/pi
		}
!
!  compute right-hand side.
!
	do k = 1,nwall(l)
		rhs(i0+k) = psi(k)-psi(1)
	i0 = i0+nwall(l)
	}
!
!  solve system
!
do i = 1,matdim
	do j = i+1,matdim
		rhs(j) = rhs(j)-rmatrx(j,i)*rhs(i)
do i = 0,matdim-1 {
	rhs(matdim-i) = rmatrx(matdim-i,matdim-i)*rhs(matdim-i)
	do j = 1,(matdim-i)-1
		rhs(j) = rhs(j)-rmatrx(j,matdim-i)*rhs(matdim-i)
	}
!
!  create new vortices.
!
nolld = nv
i0 = 0
do l = 1,nb {
	do k = 1,nwall(l) {
!
!  put the new vortex at the end of the array.
!
		nv = nv+1
		z(nv) = zcr(k,l)
		gamma(nv) = rhs(i0+k)
!
!  record the gain of linear and angular momentum
!
		force(l) = force(l)+gamma(nv)*z(nv)
		rmom(l) = rmom(l)+gamma(nv)*((z(nv)-refpt(l))**2+(z(nv)-refpt(l))**2)
		dpds(k,l) = dpds(k,l)-gamma(nv)
		}
!
!  filter and integrate pressure gradient to get pressure
!
	cp(1,l) = 0.
	cpm = -0.01
	do k = 2,nwall(l) {
		! cp(k,l) = cp(k-1,l)+(3.*(dpds(k,l)+dpds(k-1,l))+dpds(1+mod(k,nwall(l)),l)+dpds(1+mod(k+nwall(l)-3,nwall(l)),l))/(4.*delta*cupst)
		cp(k,l) = cp(k-1,l)+(3.*(dpds(k,l)+dpds(k-1,l))+dpds(1+k/nwall(l),l)+dpds(1+(k+nwall(l)-3)/nwall(l),l))/(4.*delta*cupst)
		cpm = max(cpm,cp(k,l))
		}
!
!  normalize pressure
!
	do k = 1,nwall(l)
		cp(k,l) = cp(k,l)-cpm
!
!  finish computing force and moment,  as time rate of change of linear
!  and angular momentum
!
	force(l) = force(l)*2./(delta*chord*cupst)
	rmom(l) = rmom(l)*2./(delta*chord**2*cupst)
!
	i0 = i0+nwall(l)
	}



