!
!  the version of interf used in omega3
!

common real temp, rho, tstep, boxl, boxh, cutoff, cut2
common integer nmol, norder, natmo, natmo3, nmol1

common real omas, hmas, wtmol, roh, angle, fhm, fom, rohi, rohi2

common real qq, a1, b1, a2, b2, a3, b3, a4, b4, ab1, ab2, ab3, ab4, c1, c2, qq2, qq4, ref1, ref2, ref4

common real unitt, unitl, unitm, boltz, avgno, pcc(10)

! ***********************************************************************

! subroutine interf_

formal real x(1)
formal real fx(1)
formal real xm(1)
formal real vir

    ! Builtin functions
    builtin real d_abs(), d_sign(), d_sqrt(), d_exp()

    ! Local variables
    auto integer i, j, k
    auto real ftemp, ff(14), g23, gg(14)
    auto integer kc
    auto real g45, rl(14), xl(14), rs(14), tt, g110
    auto integer iw1, iw2, jw1, jw2
    auto real tt1
    auto integer iwo, jwo

! ***********************************************************************
! 
! .....THIS ROUTINE CALCULATES INTER-MOLECULAR INTERACTION FORCES
!     THE DISTANCES ARE ARRANGED IN THE ORDER OF M-M, M-H1, M-H3, H1-M,
!     H3-M, H1-H3, H1-H1, H3-H1, H3-H3, O-O, O-H1, O-H3, H1-O, H3-O
! 
! ...Translated by Pacific-Sierra Research VAST-90 1.02A2  16:57:31   2/20/93
! 
    iw1 = 1
    iwo = 2
    iw2 = 3
    do i = 1, nmol1 {
	jw1 = iw1
	jwo = iwo
	jw2 = iw2
	do j = i + 1, nmol {
	    jw1 = jw1 + 3
	    jwo = jwo + 3
	    jw2 = jw2 + 3
!           CALL CSHIFT (X(IW1), X(JW1), XM(I), XM(J), XL, BOXH, BOXL)
	    xl(1) = xm(i) - xm(j)
	    xl(2) = xm(i) - x(jw1)
	    xl(3) = xm(i) - x(jw1 + 2)
	    xl(4) = x(iw1) - xm(j)
	    xl(5) = x(iw1 + 2) - xm(j)
	    xl(6) = x(iw1) - x(jw1)
	    xl(7) = x(iw1) - x(jw1 + 2)
	    xl(8) = x(iw1 + 2) - x(jw1)
	    xl(9) = x(iw1 + 2) - x(jw1 + 2)
	    xl(10) = x(iw1 + 1) - x(jw1 + 1)
	    xl(11) = x(iw1 + 1) - x(jw1)
	    xl(12) = x(iw1 + 1) - x(jw1 + 2)
	    xl(13) = x(iw1) - x(jw1 + 1)
	    xl(14) = x(iw1 + 2) - x(jw1 + 1)
	    do k = 1, 14 {
		if (d_abs(xl(k)) > boxh) then
		    xl(k) = xl(k) - d_sign(boxl, xl(k))
		endif
	    }

	    kc = 0
	    do k = 1, 9 {
		rs(k) = xl(k) * xl(k)
		if (rs(k) > cut2) then
		    kc = kc + 1
		endif
	    }
	    if (kc != 9) then
		if (rs(1) < cut2) then
		    vir = vir + ff(1) * rs(1)
		endif
		do k = 2, 5 {
		    if (rs(k) < cut2) then
			vir = vir + ff(k) * rs(k)
		    endif
		    if (rs(k + 4) <= cut2) then
			rl(k + 4) = d_sqrt(rs(k + 4))
			vir = vir + ff(k + 4) * rs(k + 4)
		    endif
		}
		if (kc == 0) then
		    do k = 11, 14 {
			ftemp = ab2 * d_exp(-b2 * rl(k - 5)) / rl(k - 5)
			vir = vir + ftemp * rs(k - 5)
			rs(k) = xl(k) * xl(k)
			rl(k) = d_sqrt(rs(k))
			vir = vir + ff(k) * rs(k)
		    }
		endif

		fx(iwo) = fx(iwo) + g110 + gg(11) + gg(12) + c1 * g23
		fx(jwo) = fx(jwo) - g110 - gg(13) - gg(14) - c1 * g45
		fx(iw1) = fx(iw1) + gg(6) + gg(7) + gg(13) + tt + gg(4)
		fx(iw2) = fx(iw2) + gg(8) + gg(9) + gg(14) + tt + gg(5)
		fx(jw1) = fx(jw1) - gg(6) - gg(8) - gg(11) - tt - gg(2)
		fx(jw2) = fx(jw2) - gg(7) - gg(9) - gg(12) - tt - gg(3)
	    endif
	}
	iw1 = iw1 + 3
	iwo = iwo + 3
	iw2 = iw2 + 3
    }
    return 0

